﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Documents.Excel;

namespace ExportGridWithMultipleRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = getData();            
            this.ultraGridExcelExporter1.BeginExport += UltraGridExcelExporter1_BeginExport;
            
        }

       

        private void UltraGridExcelExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventArgs e)
        {
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns) {
                if(col.Key.Equals("ID")) e.Layout.Bands[0].Columns["ID"].Width = 350;

                e.Layout.Bands[0].Columns["A"].Hidden=true;
            } 
        }

        public DataTable getData()
        {

            DataTable dt = new DataTable();

            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("A", typeof(string));
            dt.Columns.Add("B", typeof(string));
            dt.Columns.Add("C", typeof(string));
            dt.Columns.Add("D", typeof(string));
            dt.Columns.Add("E", typeof(string));
            dt.Columns.Add("F", typeof(string));
            dt.Columns.Add("G", typeof(string));

            for (int i = 1; i <= 50; i++)
            {
                var row = dt.Rows.Add();
                row[0] = i;
                row[1] = "A" + i.ToString();
                row[2] = "B" + i.ToString();
                row[3] = "C" + i.ToString();
                row[4] = "D" + i.ToString();
                row[5] = "E" + i.ToString();
                row[6] = "F" + i.ToString();
                row[7] = "G" + i.ToString();

            }

            var keys = new DataColumn[1];
            keys[0] = dt.Columns["ID"];

            dt.PrimaryKey = keys;

            return dt;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\\GridExport1.xlsx";
            this.ultraGridExcelExporter1.ExportAsync(this.ultraGrid1, path);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //e.Layout.Override.CellAppearance.BackColor = Color.Red;
            //e.Layout.Override.CellAppearance.ForeColor = Color.White;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\\GridExport.xlsx";
            string path2 = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\\NewGridExport.xlsx";

            //Loading the Excel file and the specific sheet that the data should be exported 
            Workbook workbook = Workbook.Load(path);
            Worksheet worksheet = (Worksheet)workbook.Sheets["Sheet1"];
           

            for (int i = 0; i < this.ultraGrid1.Rows.Count; i++) {
                worksheet.Rows[i+1].Cells[0].Value = this.ultraGrid1.Rows[i].Cells[0].Value;
                worksheet.Rows[i + 1].Cells[1].Value = this.ultraGrid1.Rows[i].Cells[3].Value;
                worksheet.Rows[i + 1].Cells[2].Value = this.ultraGrid1.Rows[i].Cells[4].Value;

            }

            //Saving the file under a different name in order to compare if the width of the columns as well as other formatting is preserved
            workbook.Save(path2);
            MessageBox.Show("Exporting Successful!");
        }
    }
}
